#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "QColorRampEditor.h"
#include    <cstdlib>
#include    <ctime>
#include    <sys/timeb.h>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    //QGLFormat f;
    //f.setDoubleBuffer( true );
    //esc = new escena();
    texW = new textureWidget();
    esc = new escena();
    //esc->setFormat(f);

    centralWidget = new QWidget;
    setCentralWidget(centralWidget);

    glWidgetArea2 = new QScrollArea;
    this->layoutStack2 = new QStackedLayout();
    glWidgetArea2->setLayout(layoutStack2);
    glWidgetArea2->setWidgetResizable(true);
    glWidgetArea2->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    glWidgetArea2->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    glWidgetArea2->setSizePolicy(QSizePolicy::Ignored, QSizePolicy::Ignored);
    glWidgetArea2->setMinimumSize(50, 50);

    glWidgetArea3 = new QScrollArea;
    this->layoutStack3 = new QStackedLayout();
    glWidgetArea3->setLayout(layoutStack3);
    glWidgetArea3->setWidgetResizable(true);
    glWidgetArea3->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    glWidgetArea3->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    glWidgetArea3->setSizePolicy(QSizePolicy::Ignored, QSizePolicy::Ignored);
    glWidgetArea3->setMinimumSize(50, 50);

    createActions();
    createMenus();

    // Layout central
    centralLayout = new QGridLayout;
//    centralLayout->addWidget(glWidgetArea, 1, 0);
    centralLayout->addWidget(glWidgetArea2, 1, 1);
    centralLayout->addWidget(glWidgetArea3, 1, 0);
//    QLabel *label1 = new QLabel("Model tridimensional extret de escaner medic");
//    centralLayout->addWidget(label1, 0,0);
    QLabel *label2 = new QLabel("RayCasting CPU Output");
    centralLayout->addWidget(label2, 0,1);
    QLabel *label3 = new QLabel("RayCasting GPU Output");
    centralLayout->addWidget(label3, 0,0);



    setWindowTitle(tr("Ray Casting Project"));
    resize(700, 700);
//    resize(600, 300);
//    layoutStack->addWidget(esc);
//    layoutStack->setCurrentWidget(esc);
    layoutStack2->addWidget(texW);
    layoutStack2->setCurrentWidget(texW);
    layoutStack3->addWidget(esc);
    layoutStack3->setCurrentWidget(esc);

    centralWidget->setLayout(centralLayout);


    opacitat = 1.0;
    saturacio = 0;
    sampling = 1.0;
    opacitat = 1.0;
    saturacio = 0;
    opacitat = 1.0;
    saturacio = 0;
    sampling = 1.0;
    volum = false;

    initRcInteractiveComponents();

}

void MainWindow::initRcInteractiveComponents(){


    umbralSampling = new QSlider(Qt::Horizontal);
    umbralOpacitat = new QSlider(Qt::Horizontal);
    umbralSaturacio = new QSlider(Qt::Horizontal);

    opacitatLabelGPU = new QLabel(QString::number(opacitat*100) + "%");
    saturacioLabelGPU = new QLabel(QString::number(saturacio) + "%");
    samplingLabelGPU = new QLabel(QString::number(sampling*100) + "%");

    //settejem un rang per tal de restringir els valors possibles
    umbralOpacitat->setRange(0,100);
    umbralSaturacio->setRange(0,255);
    umbralSampling->setRange(0,100);
    //settejem un size per tal que al fer slide el valor que obtinguem sigui més acurat
    umbralOpacitat->setMaximumHeight(20);
    umbralSaturacio->setMaximumHeight(20);
    umbralSampling->setMaximumHeight(20);
    //settejem els valors anteriors per tal de tenir un control més acurat
    umbralOpacitat->setValue(opacitat*100);
    umbralSaturacio->setValue(saturacio);
    umbralSampling->setValue(sampling*100);
    //els fem actius
    umbralOpacitat->setEnabled(true);
    umbralSaturacio->setEnabled(true);
    umbralSampling->setEnabled(true);


    QGridLayout *slidersLayout = new QGridLayout;
    QLabel *samp = new QLabel("Valor de mostreig del raig");
    slidersLayout->addWidget(samp,0,0);
    slidersLayout->addWidget(umbralSampling, 1, 0);
    slidersLayout->addWidget(samplingLabelGPU, 2, 0);

    QLabel *op = new QLabel("Opacitat");
    slidersLayout->addWidget(op,3,0);
    slidersLayout->addWidget(umbralOpacitat, 4, 0);
    slidersLayout->addWidget(opacitatLabelGPU, 5, 0);

    QLabel *sat = new QLabel("Threshold");
    slidersLayout->addWidget(sat,6,0);
    slidersLayout->addWidget(umbralSaturacio, 7, 0);
    slidersLayout->addWidget(saturacioLabelGPU, 8, 0);

    QVector<QPair<qreal, QColor> > initramp;
    initramp.push_back(QPair<qreal, QColor>(0.0,QColor(255,0,0)));
    initramp.push_back(QPair<qreal, QColor>(255.0,QColor(0,0,255)));

    ramph = new QColorRampEditor(NULL, Qt::Horizontal);
    ramph->setSlideUpdate(true);
    ramph->setMappingTextVisualize(true);
    ramph->setMappingTextColor(Qt::black);
    ramph->setMappingTextAccuracy(1);
    ramph->setMaximumHeight(10);
    ramph->setRamp(initramp);

    esc->setInitialLUT(ramph->getColorTable());

    QObject::connect(ramph, SIGNAL(rampChanged()), this, SLOT(onRampChanged()));

    slidersLayout->addWidget(ramph, 9, 0);


    QGridLayout *checksLayout = new QGridLayout;

    QLabel *colorsLabel = new QLabel("COLOR MODES");
    checksLayout->addWidget(colorsLabel, 0, 1);
    QLabel *rcGPUModesLabel = new QLabel("RC GPU MODES");
    checksLayout->addWidget(rcGPUModesLabel, 0, 3);


    gsCheck = new QRadioButton;
    QLabel *gsLabel = new QLabel("Gray scale");
    gsCheck->setMaximumSize(20,20);
    checksLayout->addWidget(gsCheck, 1, 0);
    checksLayout->addWidget(gsLabel, 1, 1);

    lutCheck = new QRadioButton;
    QLabel *lutLabel = new QLabel("Lut");
    lutCheck->setMaximumSize(20,20);
    checksLayout->addWidget(lutCheck, 2, 0);
    checksLayout->addWidget(lutLabel, 2, 1);

    phongCheck = new QRadioButton;
    QLabel *phongLabel = new QLabel("Phong Blinn");
    phongCheck->setMaximumSize(20,20);
    checksLayout->addWidget(phongCheck, 3, 0);
    checksLayout->addWidget(phongLabel, 3, 1);

    oneStepCheck = new QCheckBox;
    QLabel *oneStepLabel = new QLabel("One Step");
    oneStepCheck->setMaximumSize(20,20);
    oneStepCheck->setChecked(false);
    checksLayout->addWidget(oneStepCheck, 1, 2);
    checksLayout->addWidget(oneStepLabel, 1, 3);

    MipCheck = new QRadioButton;
    QLabel *MipLabel = new QLabel("MIP");
    MipCheck->setMaximumSize(20,20);
    MipCheck->setChecked(false);
    checksLayout->addWidget(MipCheck, 4, 0);
    checksLayout->addWidget(MipLabel, 4, 1);


    gsCheck->setChecked(true);
    lutCheck->setChecked(false);
    phongCheck->setChecked(false);

//    slidersLayout->addLayout(checksLayout, 9, 0, 1, 1, Qt::AlignCenter);
    centralLayout->addLayout(checksLayout, 3,1,1,1,Qt::AlignCenter);
    centralLayout->addLayout(slidersLayout, 3,0,1,1,Qt::AlignCenter);

    QObject::connect(umbralOpacitat, SIGNAL(sliderMoved(int)),this, SLOT(setOpacitatGPU(int)));
    QObject::connect(umbralSaturacio, SIGNAL(sliderMoved(int)),this, SLOT(setSaturacioGPU(int)));
    QObject::connect(umbralSampling, SIGNAL(sliderMoved(int)),this, SLOT(setSamplingGPU(int)));
    QObject::connect(gsCheck, SIGNAL(clicked()),this,SLOT(setGsMode()));
    QObject::connect(lutCheck, SIGNAL(clicked()),this,SLOT(setLutMode()));
    QObject::connect(phongCheck, SIGNAL(clicked()),this,SLOT(setPhongMode()));
    QObject::connect(oneStepCheck, SIGNAL(clicked()),this,SLOT(setOneStepRaycastingGPU()));
    QObject::connect(MipCheck, SIGNAL(clicked()),this,SLOT(setMipMode()));

}

void MainWindow::createActions()
{

    addVolumen = new QAction(tr("&OpenVolumen"), this);
    addVolumen->setShortcut(QKeySequence::Open);
    addVolumen->setStatusTip(tr("Abrir el Volumen"));
    connect(addVolumen, SIGNAL(triggered()), this, SLOT(canvioDeAtributos()));

    exitAct = new QAction(tr("&Exit"), this);
    exitAct->setShortcut(tr("Ctrl+Q"));
    exitAct->setStatusTip(tr("Sorti del programa"));
    connect(exitAct, SIGNAL(triggered()), qApp, SLOT(closeAllWindows()));

    CPU = new QAction(tr("CPU"), this);
    CPU->setShortcut(tr("Ctrl+A"));
    CPU->setStatusTip(tr("Fer RayCasting de volum a la CPU"));
    connect(CPU, SIGNAL(triggered()), this, SLOT(rcCPU()));

    GPU = new QAction(tr("&GPU"), this);
    GPU->setShortcut(tr("Ctrl+S"));
    GPU->setStatusTip(tr("Fer RayCasting de volum a la GPU"));
    connect(GPU, SIGNAL(triggered()), this, SLOT(rcGPU()));
}

void MainWindow::createMenus()
{
    fileMenu = menuBar()->addMenu(tr("&File"));

    fileMenu->addSeparator();
    fileMenu->addAction(addVolumen);

    fileMenu->addSeparator();
    fileMenu->addAction(exitAct);

    rcMenu = menuBar()->addMenu(tr("&RayCasting"));

    rcMenu->addSeparator();
    rcMenu->addAction(CPU);

    rcMenu->addSeparator();
    rcMenu->addAction(GPU);

}



void MainWindow::canvioDeAtributos()
{
    printf("\n Pasando por cambio de atributos \n");

    integerSpinBox1 = new QSpinBox();
    integerSpinBox2 = new QSpinBox();
    integerSpinBox3 = new QSpinBox();

    unsig = new QComboBox();

    //AÃ±ado los dos items que quiero
    unsig->addItem("unsigned char");
    unsig->addItem("unsigned short");

    //Creo una ventana nueva con dos botones uno de aplicar y otro de aceptar
    window = new QWidget;
    buttonBox = new QDialogButtonBox(QDialogButtonBox::Ok);

    //Creo un layout para colocar los spinbox
    QFormLayout *layout = new QFormLayout();

    //Cambio el valor por defecto maximo de los spinbox
    integerSpinBox1->setRange(0,1000);
    integerSpinBox2->setRange(0,1000);
    integerSpinBox3->setRange(0,1000);
    integerSpinBox1->setValue(128);
    integerSpinBox2->setValue(128);
    integerSpinBox3->setValue(128);

    //Pongo en el layout los spinbox con su nombre
    layout->addRow(new QLabel(tr("Anchura:")), integerSpinBox1);
    layout->addRow(new QLabel(tr("Altura:")), integerSpinBox2);
    layout->addRow(new QLabel(tr("Profundidad:")), integerSpinBox3);
    layout->addRow(new QLabel(tr("Unsigned")), unsig);
    //AÃ±ado el boton para aplicar el cambio
    layout->addWidget(buttonBox);

    //Muestro el layout
    window->setWindowTitle("OpenVolumen");
    window->setLayout(layout);
    window->show();

    //Cuando pulse el boton ok me manda a cargarVolumen para elegir el fichero
    connect(buttonBox, SIGNAL(accepted()),this, SLOT(aplicarCambios()));
}

void MainWindow::aplicarCambios(){
    printf("\n Paso por aplicar cambios \n");

    char* nF;
    nF = (char *)malloc(200*sizeof(char));
    int anch = 0;
    int alt = 0;
    int profu = 0;
    QString tipoUns = "";
    volumen *v;
    v = new volumen(); //El constructor lo hago por defecto porque no tengo datos algunos aun
    anch = integerSpinBox1->value();
    printf("\n Anchura %u \n ", anch);
    alt = integerSpinBox2->value();
    printf("\n Altura %u \n ", alt);
    profu = integerSpinBox3->value();
    printf("\n Profundidad %u \n ", profu);
    tipoUns = unsig->currentText();
    v->openVolumen(anch, alt, profu, tipoUns);
    window->close();
    //Cargar el volumen
    cargarVolumen(v);
}

void MainWindow::cargarVolumen(volumen *v)
{
    //Abro una pantalla de eleccion de fichero y me guardo la ruta y se la envio al volumen
    char* fichero;

    fichero = (char *)malloc(200*sizeof(char));
    QString fi = QFileDialog::getOpenFileName(this);
    if( fi.isEmpty() )
      return;
    QGLContext *contexto = NULL;
    strcpy(fichero, fi.toStdString().c_str());
//    if (layoutStack->currentWidget()!=NULL)
//        contexto = ( QGLContext *)((escena*)layoutStack->currentWidget())->context();
    printf("\n Pasa por cargar volumen \n");

    v->setFichero(fichero);
    v->abrirVolumen();

//    esc->addVolumen2(v); // Este metodo se encarga de crear el nuevo volumen y guardarlo en la lista de volumenes
    esc->addVolumen(v);
    volum = true;
    esc->eliminaCub();
    QAction *volumen = new QAction(fi, this);
    //reseteaOtrosMundos();

    volumen->setStatusTip(fi);
    volumen->setCheckable(true);
    volumen->setChecked(true);
}


void MainWindow::rcCPU() {

    clock_t startC, finishC;
    struct timeb startT, finishT;
    unsigned int seconds, milliseconds;

    startC = clock();
    ftime(&startT);

    //--------------------------------------------------------


    if(volum){

        esc->raycastingCPU(opacitat, saturacio, sampling);
        texW->showRaycastingCPUResult();

    } else {
        QMessageBox *qMessBox = new QMessageBox(QMessageBox::Warning, "Alerta", "No pots activar el Ray Casting si no has obert cap volum.", QMessageBox::Ok);
        qMessBox->show();
    }
    //--------------------------------------------------------

    finishC = clock();
    ftime(&finishT);
    seconds = finishT.time - startT.time - 1;
    milliseconds = (1000 - startT.millitm) + finishT.millitm;

    cout << "Time (clock): "    << (finishC - startC)/CLOCKS_PER_SEC << endl;
    cout << "Time (difftime): " << difftime(finishC, startC) << endl;
    cout << "Time (ftime): " << (milliseconds + seconds * 1000) << endl;

}

void MainWindow::rcGPU() {

    clock_t startC, finishC;
    struct timeb startT, finishT;
    unsigned int seconds, milliseconds;

    startC = clock();
    ftime(&startT);

    //--------------------------------------------------------
    if(volum){
        esc->setOpacitat(opacitat);
        esc->setSaturacio(saturacio);
        esc->setSampling(sampling);
        esc->startRaycasting();
    } else {
        QMessageBox *qMessBox = new QMessageBox(QMessageBox::Warning, "Alerta", "No pots activar el Ray Casting si no has obert cap volum.", QMessageBox::Ok);
        qMessBox->show();
    }

    //--------------------------------------------------------

    finishC = clock();
    ftime(&finishT);
    seconds = finishT.time - startT.time - 1;
    milliseconds = (1000 - startT.millitm) + finishT.millitm;

    cout << "Time (clock): "    << (finishC - startC)/CLOCKS_PER_SEC << endl;
    cout << "Time (difftime): " << difftime(finishC, startC) << endl;
    cout << "Time (ftime): " << (milliseconds + seconds * 1000) << endl;

}

void MainWindow::setOpacitat(int o){
    opacitat = (float)o/100.0;
    opacitatLabel->setText(QString::number(opacitat*100) + "%");
}
void MainWindow::setSaturacio(int sat){
    saturacio = sat;
    saturacioLabel->setText(QString::number(saturacio));
}
void MainWindow::setSampling(int sam){
    sampling = (float)sam/100.0f;
    samplingLabel->setText(QString::number(sampling*100) + "%");
}

void MainWindow::setOpacitatGPU(int o)
{
    clock_t startC, finishC;
    struct timeb startT, finishT;
    unsigned int seconds, milliseconds;

    startC = clock();
    ftime(&startT);

    //--------------------------------------------------------

    opacitat = (float)o/100.0;
    opacitatLabelGPU->setText(QString::number(opacitat*100) + "%");
    esc->setOpacitat(opacitat);

    //--------------------------------------------------------

    finishC = clock();
    ftime(&finishT);
    seconds = finishT.time - startT.time - 1;
    milliseconds = (1000 - startT.millitm) + finishT.millitm;

    cout << "Time (clock): "    << (finishC - startC)/CLOCKS_PER_SEC << endl;
    cout << "Time (difftime): " << difftime(finishC, startC) << endl;
    cout << "Time (ftime): " << (milliseconds + seconds * 1000) << endl;
}

void MainWindow::setSaturacioGPU(int sat)
{

    clock_t startC, finishC;
    struct timeb startT, finishT;
    unsigned int seconds, milliseconds;

    startC = clock();
    ftime(&startT);

    //--------------------------------------------------------

    saturacio = sat;
    saturacioLabelGPU->setText(QString::number(saturacio));
    esc->setSaturacio(saturacio);

    //--------------------------------------------------------

    finishC = clock();
    ftime(&finishT);
    seconds = finishT.time - startT.time - 1;
    milliseconds = (1000 - startT.millitm) + finishT.millitm;

    cout << "Time (clock): "    << (finishC - startC)/CLOCKS_PER_SEC << endl;
    cout << "Time (difftime): " << difftime(finishC, startC) << endl;
    cout << "Time (ftime): " << (milliseconds + seconds * 1000) << endl;
}

void MainWindow::setSamplingGPU(int sam){

    clock_t startC, finishC;
    struct timeb startT, finishT;
    unsigned int seconds, milliseconds;

    startC = clock();
    ftime(&startT);

    //--------------------------------------------------------

    sampling = (float)sam/100.0f;
    samplingLabelGPU->setText(QString::number(sampling*100) + "%");
    esc->setSampling(sampling);

    //--------------------------------------------------------

    finishC = clock();
    ftime(&finishT);
    seconds = finishT.time - startT.time - 1;
    milliseconds = (1000 - startT.millitm) + finishT.millitm;

    cout << "Time (clock): "    << (finishC - startC)/CLOCKS_PER_SEC << endl;
    cout << "Time (difftime): " << difftime(finishC, startC) << endl;
    cout << "Time (ftime): " << (milliseconds + seconds * 1000) << endl;
}

void MainWindow::onRampChanged()
{
    clock_t startC, finishC;
    struct timeb startT, finishT;
    unsigned int seconds, milliseconds;

    startC = clock();
    ftime(&startT);

    //--------------------------------------------------------

    esc->setRampColorTable(ramph->getColorTable());

    //--------------------------------------------------------

    finishC = clock();
    ftime(&finishT);
    seconds = finishT.time - startT.time - 1;
    milliseconds = (1000 - startT.millitm) + finishT.millitm;

    cout << "Time (clock): "    << (finishC - startC)/CLOCKS_PER_SEC << endl;
    cout << "Time (difftime): " << difftime(finishC, startC) << endl;
    cout << "Time (ftime): " << (milliseconds + seconds * 1000) << endl;

}

void MainWindow::setGsMode()
{
    lutCheck->setChecked(false);
    phongCheck->setChecked(false);
    MipCheck->setChecked(false);
//    esc->setMipMode(MipCheck->isChecked());

    esc->setColorMode(gsMode);
}

void MainWindow::setLutMode()
{
    gsCheck->setChecked(false);
    phongCheck->setChecked(false);
    MipCheck->setChecked(false);
//    esc->setMipMode(MipCheck->isChecked());

    esc->setColorMode(lutMode);
}

void MainWindow::setPhongMode()
{
    gsCheck->setChecked(false);
    lutCheck->setChecked(false);
    MipCheck->setChecked(false);
//    esc->setMipMode(MipCheck->isChecked());

    esc->setColorMode(phongMode);
}

void MainWindow::setMipMode()
{

    gsCheck->setChecked(false);
    lutCheck->setChecked(false);
    phongCheck->setChecked(false);

    esc->setColorMode(mipMode);

}

void MainWindow::setOneStepRaycastingGPU()
{

    esc->setOneStepRaycastingMode(oneStepCheck->isChecked());

}



MainWindow::~MainWindow()
{
    delete ui;
}
