#define GL_GLEXT_PROTOTYPES

#include <QtGui>
#include <QtOpenGL>
#include <string>
#include "volumen.h"
#include "etiqueta.h"
#include "lut.h"


using namespace std;

volumen::volumen()
{
    //voxels = (float *)malloc (anchura*altura*profundidad*sizeof(float));
    planox = 1.0f;
    planoy = 1.0f;
    planoz = 1.0f;
    lista = -1;
    xRot = 0;
    yRot = 0;
    zRot = 0;
    xorig = 0;
    yorig = 0;
    zorig = -40;
    colores = NULL;
    uns = 0;
    raig = new Raig();
    materialPrimari = 0;
    materialSecundari = 0;
    altura = 0;
    anchura = 0;
    profundidad = 0;
}

volumen::~volumen()
{

   glDeleteLists(lista,1);
}

//Constructor de Volumen
void volumen::abrirVolumen()
{
    printf("Estoy en el abrirVolumen \n");
    int k;
    int j;
    int i;
    int ret;
    unsigned char v;
    unsigned short vo;

    uns = strcmp(unsCS,"unsigned char")!=0;
    printf("UNS %d\n",uns);
    printf("UNSCS %s\n",unsCS);

    voxels = (float *)malloc (anchura*altura*profundidad*sizeof(float));
    capas = (unsigned char*)malloc(anchura*altura*profundidad*sizeof(unsigned char));
    memset(capas,0,anchura*altura*profundidad*sizeof(unsigned char));
    printf("\n %s \n", nombreFichero);
    f1 = fopen(nombreFichero, "rb");

    if (f1 == NULL) {
        fputs ("File error",stderr);
        exit (1);
    }
    printf("\n Anchura %u \n ", anchura);
    printf("\n Altura %u \n ", altura);
    printf("\n Profundidad %u \n ", profundidad);
    printf("\n");

//    int c=0, b;
//    while ((b=fgetc(f1))!=EOF) c++;
//    cout<<"lines --> "<<c<<endl;

    float maximo = 0.0;
    for (k=0; k<profundidad; k++) {
        for (j=0; j<altura; j++) {
            for (i=0; i<anchura; i++) {
                //short o char
                float valor;

                if(uns == 0){
                    ret = fread(&v, 1, sizeof(unsigned char), f1);
                    if (ret){
                        valor = v;
                    }
                } else {
                    ret = fread(&vo, 1, sizeof(unsigned short), f1);
                    if (ret){
                        valor = vo;
                    }
                }
                if (maximo < valor)
                    maximo = valor;
                setVoxel(i,j,k,valor);
            }
        }
    }
    fclose(f1);
}


float volumen::getVoxelDirecto(int voxel)
{
    return voxels[voxel];
}



void volumen::addListaVoxels(float x,float y,float z,float v,float i)
{
    listaVoxels.append(x);
    listaVoxels.append(y);
    listaVoxels.append(z);
    listaVoxels.append(v);
    listaVoxels.append(i);
    printf("X: %f Y: %f Z: %f V: %f ID: %f\n", listaVoxels.at(0),listaVoxels.at(1),listaVoxels.at(2),listaVoxels.at(3),listaVoxels.at(4));
}

void volumen::openVolumen(int a, int al, int p, QString t)
{
    anchura = a;
    altura = al;
    profundidad = p;

    NumVoxelsMon = anchura*altura*profundidad;

//    points = new vec4[NumVoxelsMon];
//    normals = new vec3[NumVoxelsMon];
//    colors = new vec4[NumVoxelsMon];

    const char *prov;
    prov = t.toStdString().c_str();
    unsCS = (char *)malloc(strlen(prov)*sizeof(char) +1 );
    strcpy(unsCS,prov);
}

void volumen::setVoxel(int i, int j, int k ,float v)
{
    voxels[i+j*anchura+k*anchura*altura] = v;
}

float volumen::getVoxel(int i, int j, int k)
{
    return voxels[i+j*anchura+k*anchura*altura];
}

void volumen::setLut(const char* nF)
{
    if (colores != NULL)
        delete colores;
    colores = new lut(nF);
}

const char * volumen::getFichero()
{
    return nombreFichero;
}

void volumen::setFichero(char* fi)
{
    nombreFichero = fi;
}

int volumen::getAnchura()
{
    return anchura;
}

void volumen::setAnchura(int an)
{
    anchura = an;
}

int volumen::getAltura()
{
    return altura;
}

void volumen::setAltura(int al)
{
    altura = al;
}

int volumen::getProfundidad()
{
    return profundidad;
}

void volumen::setProfundidad(int pro)
{
    profundidad = pro;
}

QString volumen::getTipoUns()
{
    return unsCS;
}

void volumen::setTipoUns(char* unsC)
{
    unsCS = unsC;
}

char* volumen::getImagen()
{
    return imagen;
}

void volumen::setImagen(char* im)
{
    imagen = im;
}

QList<char *> volumen::obtenerEtiqueta()
{
    return etiquetas;
}

void volumen::make()
{
    // ACELERAR
   /* if (lista != -1)
        glDeleteLists(lista,1);

        lista = glGenLists(1);
        glNewList(lista,GL_COMPILE)*/;
//        int tamaPunto = 1;
        int k = 0;
        int j = 0;
        int i = 0;
        int index = 0;
        float valor;
        float anchtemp = 1.0f/(anchura/4.0f);
        float alttemp= 1.0f/(altura/4.0f);
        float proftemp= 1.0f/(profundidad/4.0f);

//        glPointSize(tamaPunto);
//        glBegin(GL_POINTS);
//        glNormal3f(1,1,0);


       // printf("P: %d, A: %d, An: %d", profundidad, anchura, altura);

//        if (colores){
//            for (k=0;k<profundidad*planoz;k+=1) {
//                for (j=0; j<altura*planoy; j+=1) {
//                    for (i=0; i<anchura*planox; i+=1) {
//                        //valor = getVoxelDirecto(voxel); //acceder al valor de voxels[i,j,k]
//                        valor = getVoxel(i,j,k);

////                        glColor4fv(colores->getColor(valor)); //colors 128x128x128
////                        glVertex3f(i*anchtemp,j*alttemp,k*proftemp); //points 128x128x128

//                        if(valor > 40){
//                            colors[index] = vec4(colores->getColor(valor)[0],colores->getColor(valor)[1],
//                                                        colores->getColor(valor)[2],colores->getColor(valor)[3]);
//                            points[index] = vec4(i,j,k,1.0);
//                            normals[index] = vec3(1,1,0);
//                        }else {
//                            colors[index] = vec4(1.0,1.0,1.0,0.0);
//                            points[index] = vec4(i,j,k,0.0);
//                            normals[index] = vec3(1,1,0);
//                        }
//                        index++;
//                    }
//                }
//            }
//         } else {
//            for (k=0;k<profundidad*planoz;k+=1) {
//                for (j=0; j<altura*planoy; j+=1) {
//                    for (i=0; i<anchura*planox; i+=1) {
//                        //valor = getVoxelDirecto(voxel); //acceder al valor de voxels[i,j,k]
//                        valor = getVoxel(i,j,k);
                        //cout<<valor<<" valor !"<<endl;
//                        glColor4f(valor/255,valor/255,valor/255,valor/255);
//                        glVertex3f(i*anchtemp,j*alttemp,k*proftemp);

//
//                            colors[index] = vec4(valor/255,valor/255,valor/255,valor/255);
//                            points[index] = vec4(i,j,k,1.0);
//                            normals[index] = vec3(1,1,0);
//
//                        index++;
//                    }
//                }
//            }
//         }

         /*glEnd();
         glEndList()*/;
}

void volumen::draw(GLdouble dx, GLdouble dy, GLdouble dz)
{


    glPushMatrix();
    glTranslated(dx, dy, dz);
 // PARA ACELERAR
    glCallList(lista);
    glPopMatrix();
}

vec4 volumen::getColorActual(int mode, float v, int i, int j, int k, Llum *llum, vec4 colorMax)
{

    vec4 color = vec4(0.0,0.0,0.0,0.0);
    vec4 normal = vec4(0.0,0.0,0.0,0.0);
    vec4 prevColor = vec4(0.0,0.0,0.0,0.0);
    vec4 nextColor = vec4(0.0,0.0,0.0,0.0);


    if(mode == GS_MODE){

        color = vec4(v/255, v/255, v/255, v/255);
        if(color.x*255 < UMBRAL_SATURACIO)
            color = vec4(0.0,0.0,0.0,0.0);
//        color = vec4(0.0,0.0,0.0,1.0);

    }else if(mode == LUT_MODE) {

        if(v > UMBRAL_SATURACIO){
            float *aux = colores->getColor(v);
            color = vec4(aux[0], aux[1], aux[2], aux[3]);
        }

    }else if (mode == PHONG_MODE){


        float actValue = v;

        if(i>=0&&i<anchura&&j>=0&&j<altura&&k>=0&&k<profundidad){

            float vVoxelAnterior = getVoxel(i-1, j, k);
            float vVoxelPosterior = getVoxel(i+1, j, k);
            prevColor.x = vVoxelAnterior/255;
            nextColor.x = vVoxelPosterior/255;
            vVoxelAnterior = getVoxel(i, j-1, k);
            vVoxelPosterior = getVoxel(i, j+1, k);
            prevColor.y = vVoxelAnterior/255;
            nextColor.y = vVoxelPosterior/255;
            vVoxelAnterior = getVoxel(i, j, k-1);
            vVoxelPosterior = getVoxel(i, j, k+1);
            prevColor.z = vVoxelAnterior/255;
            nextColor.z= vVoxelPosterior/255;

            if(actValue > UMBRAL_SATURACIO /*&& actValue > 40*/){

                normal = vec4(normalize(vec3(nextColor.x, nextColor.y, nextColor.z) - vec3(prevColor.x, prevColor.y, prevColor.z)),1.0);

    //            vec3 N = normalize(normal.xyz);
                vec3 N = vec3(normal.x,normal.y,normal.z);
                vec3 V = normalize(vec3((float)i, (float)j, (float)k));
                vec4 llumPos = llum->getPosicio();
                vec3 L = normalize(vec3(llumPos.x, llumPos.y, llumPos.z));

                vec3 H = normalize( L + V );

                float dotProdLN = (float)dot(L,N);
                float constDifusa = 0.0f;
                if (dotProdLN > 0.001){
                    constDifusa = dotProdLN;
                }

                float dotProdNH = (float)dot(H,N);
                float constEspecular = 0.0f;
                if (dotProdNH > 0.001){
                    constEspecular = pow(dotProdNH, materialPrimari->getShininess());
                }

                float *aux = colores->getColor(v);

                color = (llum->getAmbient() * materialPrimari->getAmbient())
                                         + (constDifusa * llum->getDifusa() * vec4(aux[0], aux[1], aux[2], aux[3]))
                                         + (constEspecular * llum->getEspecular() * materialPrimari->getEspecular());

            //color.w = 1.0;
            } else {
                color = vec4(0.0,0.0,0.0,1.0);
            }

        } else {
            color = vec4(0.0,0.0,0.0,0.0);
        }
    } else if (mode == MIP_MODE) {
        color = vec4(v/255,v/255,v/255,v/255);
        if(color.x > colorMax.x){
            colorMax = color;
        }
        if(colorMax.x*255 < UMBRAL_SATURACIO)
            colorMax = vec4(0.0,0.0,0.0,0.0);
        return colorMax;
    }

    return color;

}

vec4 volumen::calculIluminacioFTB(Capsa3D cub, Raig raig, int colorMode, Llum *llum){
    vec3 samplingPoint;
    vec3 pmins, pmaxs; /* PUNTS DEL CUB QUE ENVOLTA EL PUNT QUE CERQUEM (INTERPOLACIO TRILINEAL) */

    float d000, d100, d010, d001, d101, d011, d110, d111, dxyz;

    vec4 coloracum = vec4(0.0,0.0,0.0,0.0);
    vec4 colorActual = vec4(-1.0, -1.0, -1.0, -1.0);
    float alfaacum, alfaActual, v;
    float x, y ,z, fx, fy, fz;
    int x0, y0, z0, x1, y1, z1;
    int i,j,k;
    coloracum = vec4(0,0,0,0);
    alfaacum = 0;

    float lambda = tnear;

//    for(int lambda = (int) tfar; lambda >= (int) tnear; lambda--){ //Parar en el cas que alfa = 1

    while(lambda < tfar && alfaacum < 1.0){

        /* INTERPOLACIO TRILINEAL (CERCA DEL PUNT A MOSTREJAR DEL MON) */

        samplingPoint = raig.p + lambda*raig.v;
//        cout<<samplingPoint.x<<" "<<samplingPoint.y<<" "<<samplingPoint.z<<endl;
        pmins = vec3(((int)samplingPoint.x), ((int)samplingPoint.y), ((int)samplingPoint.z));
        pmaxs = vec3((int)samplingPoint.x+1, (int)samplingPoint.y+1, (int)samplingPoint.z+1);

        x = samplingPoint.x; y = samplingPoint.y; z = samplingPoint.z;

        z0 = (int)z;z1 = z0 + 1;fz = z - z0;
        y0 = (int)y;y1 = y0 + 1;fy = y - y0;
        x0 = (int)x;x1 = x0 + 1;fx = x - x0;

        if(x0>=0&&x1<cub.a&&y0>=0&&y1<cub.h&&z0>=0&&z1<cub.p){

            d000 = getVoxel(x0,y0,z0);
            d001 = getVoxel(x0,y0,z0);
            d010 = getVoxel(x0,y0,z0);
            d011 = getVoxel(x0,y0,z0);

            d100 = getVoxel(x1,y1,z1);
            d101 = getVoxel(x1,y1,z1);
            d110 = getVoxel(x1,y1,z1);
            d111 = getVoxel(x1,y1,z1);

            dxyz = (((d000*(1-fx)+d001*fx)*(1-fy)+(d010*(1-fx)+d011*fx )*fy)*(1-fz)
            + ((d100*(1-fx)+d101*fx)*(1-fy)+(d110*(1-fx)+d111*fx)*fy)*fz);

        } else {
            dxyz = 0.0f;
        }

        v = dxyz;

            if(v > UMBRAL_SATURACIO){
                alfaActual = (v/255.0)*UMBRAL_OPACITAT; //fer constants factor alfa / factor color
                if(alfaActual > 0){

                    colorActual = getColorActual(colorMode, v, x0, y0, z0, llum, colorActual);

                    coloracum = coloracum + (1-(alfaacum))*colorActual*alfaActual;

                    alfaacum = alfaacum + (1-alfaacum)*alfaActual;
                    if(alfaacum > 1.0){
                        alfaacum = 1.0;
                    }
                }
            }
        lambda += raig.incrementMostreig;
    }

    if(fabs(alfaacum-1) < 0.001)
        hit++;

    coloracum = vec4((int)(coloracum.x*255),(int)(coloracum.y*255),(int)(coloracum.z*255), (int)(coloracum.w*255));
//    cout<<"coloracum: "<<coloracum<<endl;
    if(colorMode == MIP_MODE){
        return colorActual*255;
    }
    return coloracum;

}


bool volumen::intersecta(Raig *raig, Capsa3D cub, float t0, float t1){
    float tmin, tmax, tymin, tymax, tzmin, tzmax;
    if (raig->v.x >= 0) {
        tmin = (cub.pmin.x - raig->p.x) / raig->v.x;
        tmax = (cub.a - raig->p.x) / raig->v.x;
    }
    else {
        tmin = (cub.a - raig->p.x) / raig->v.x;
        tmax = (cub.pmin.x - raig->p.x) / raig->v.x;
    }
    if (raig->v.y >= 0) {
        tymin = (cub.pmin.y - raig->p.y) / raig->v.y;
        tymax = (cub.h - raig->p.y) / raig->v.y;
    }
    else {
        tymin = (cub.h - raig->p.y) / raig->v.y;
        tymax = (cub.pmin.y - raig->p.y) / raig->v.y;
    }
    if ( (tmin > tymax) || (tymin > tmax) )
        return false;
    if (tymin > tmin)
        tmin = tymin;
    if (tymax < tmax)
        tmax = tymax;
    if (raig->v.z >= 0) {
        tzmin = (cub.pmin.z - raig->p.z) / raig->v.z;
        tzmax = (cub.p - raig->p.z) / raig->v.z;
    }
    else {
        tzmin = (cub.p - raig->p.z) / raig->v.z;
        tzmax = (cub.pmin.z - raig->p.z) / raig->v.z;
    }
    if ( (tmin > tzmax) || (tzmin > tmax) )
        return false;
    if (tzmin > tmin)
        tmin = tzmin;
    if (tzmax < tmax)
        tmax = tzmax;

    if ((tmin < t1) && (tmax > t0)){
        tnear = tmin;
        tfar = tmax;
        return ( true );
    }

    return false;

}

void volumen::raycastingCPU(Camera cam, Capsa3D cub, float opacitat, float saturacio, float sampling, int colorMode, Llum *llum){

       this->UMBRAL_OPACITAT = opacitat;
       this->UMBRAL_SATURACIO = saturacio;
       raig->incrementMostreig = sampling;
       hit = 0;

       int vwidth = cam.vp.a;  //amplitud de la imatge final (viewport)
       int vheight = cam.vp.h; //altura de la imatge final (viewport)
       int index = 0;

       mat4 MSIV;
       cam.CreaMatSiv(MSIV);

       vec3 pw;

       vec3 colors[vwidth*vheight];
       bool interseccio = false;

       if(colorMode == PHONG_MODE && materialPrimari == 0){
            materialPrimari = new Material(vec4(0.6,0.6,0.6,1), vec4(0.95,0.6,0.35,1), vec4(0.2,0.2,0.2,1), 50.0f);
       }

       for(int i = 0; i < vheight; i++){
           for(int j = 0; j < vwidth; j++){

               /*  CALCULEM EL RAIG    */
               pw.x = (j*cam.wd.a)/(float)vwidth + cam.wd.pmin[0];
               pw.y = ((i)/(float)vheight)*cam.wd.h + cam.wd.pmin[1];
               raig->calculRaig(j, i, cam.piram.d, cam.piram.proj, pw, MSIV);

               /*  TROBEM LES INTERSECCIONS tnear tfar DEL RAIG AMB EL MON DE VOXELS (CUB)    */
               tnear = -INFINITY;
               tfar = INFINITY;
               interseccio = intersecta(raig, cub, -200.0f, 200.0f);

               //Calculem la iluminacio del pixel final a dibuixar
               if(interseccio){
//                   colors[index] = calculIluminacioFTB(cub, *raig);
                   vec4 aux = calculIluminacioFTB(cub, *raig, colorMode, llum);
                   colors[index] = vec3(aux.x, aux.y, aux.z);
               }else{
                   colors[index] = vec3(1.0,1.0,1.0);
               }

           index++;

           }
       }

       /* CREEM UNA NOVA IMATGE.PPM PER A VEURE EL RESULTAT DEL RAYCASTING */

     const int dimx = vwidth, dimy = vheight;
     int m = 0;
     int n = 0;
     index = 0;
     FILE *fp = fopen("imatge.ppm", "wb"); /* b - binary mode */
     (void) fprintf(fp, "P6\n%d %d\n255\n", dimx, dimy);
     for (n = dimy; n >= 0; n--)
     {
       for (m = 0; m < dimx; m++)
       {
//            cout<<colors[index][0]<<" "<<colors[index][1]<<" "<<colors[index][2]<<endl;

//          (void) fprintf(   fp, "%c %c %c ",
//                            (unsigned char)colors[(dimx*dimy-index)-1][0],
//                            (unsigned char)colors[(dimx*dimy-index)-1][1],
//                            (unsigned char)colors[(dimx*dimy-index)-1][2] );
           unsigned char tmp[3];
           tmp[0] = (unsigned char)colors[m+n*dimx][0];
           tmp[1] = (unsigned char)colors[m+n*dimx][1];
           tmp[2] = (unsigned char)colors[m+n*dimx][2];
           (void) fwrite(tmp, sizeof(unsigned char), 3, fp);
         index++;
       }
//        (void) fprintf(fp, "\n");
     }
     (void) fclose(fp);
//   }

     cout<<hit<<" <-- hits"<<endl;

}

void volumen::draw(QGLShaderProgram *program)
{

    program->setUniformValue("anchura", (float)anchura);
    program->setUniformValue("altura", (float)altura);
    program->setUniformValue("profundidad", (float)profundidad);

    int vertexLocation = program->attributeLocation("vPosition");
    int colorLocation = program->attributeLocation("vColor");

    glBufferSubData( GL_ARRAY_BUFFER, 0, sizeof(points), points );
    glBufferSubData( GL_ARRAY_BUFFER, sizeof(points), sizeof(colors), colors );

    program->enableAttributeArray(vertexLocation);
    program->setAttributeBuffer("vPosition", GL_FLOAT, 0, 4);

    program->enableAttributeArray(colorLocation);
    program->setAttributeBuffer(colorLocation, GL_FLOAT, sizeof(points), 4);

    // Aqui visualitzaras punts i no triangles
    glDrawArrays( GL_POINTS, 0, NumVoxelsMon );
    program->disableAttributeArray(vertexLocation);
    program->disableAttributeArray(colorLocation);

}

void volumen::toGPU(QGLShaderProgram *program)
{
    std::cout<<"Passo les dades dels voxels a la GPU\n";

    program->setUniformValue("anchura", (float)anchura);
    program->setUniformValue("altura", (float)altura);
    program->setUniformValue("profundidad", (float)profundidad);

    // Creació d'un vertex array object
    GLuint vao;
    glGenVertexArrays( 1, &vao );
    glBindVertexArray( vao );

    // Creacio i inicialitzacio d'un buffer object
    GLuint buffer;
    glGenBuffers( 1, &buffer );
    glBindBuffer( GL_ARRAY_BUFFER, buffer );
    glBufferData( GL_ARRAY_BUFFER, sizeof(points) + sizeof(colors),
    NULL, GL_STATIC_DRAW );
    glBufferSubData( GL_ARRAY_BUFFER, 0, sizeof(points), points );
    glBufferSubData( GL_ARRAY_BUFFER, sizeof(points), sizeof(colors), colors );

    // set up vertex arrays

    int vertexLocation = program->attributeLocation("vPosition");
    int colorLocation = program->attributeLocation("vColor");


    program->enableAttributeArray(vertexLocation);
    program->setAttributeBuffer("vPosition", GL_FLOAT, 0, 4);
    // program->setAttributeArray(vertexLocation, points, 4, Index);

    program->enableAttributeArray(colorLocation);
    program->setAttributeBuffer(colorLocation, GL_FLOAT, sizeof(points), 4);


    program->bindAttributeLocation("vPosition", vertexLocation);
    program->bindAttributeLocation("vColor", colorLocation);
    program->link();

    program->bind();
    //glEnable( GL_DEPTH_TEST );

}

Capsa3D volumen::calculCapsa3D(){
    vec3 pmin = vec3(0.0,0.0,0.0);
    capsa.pmin = pmin;
    capsa.a = anchura;
    capsa.h = altura;
    capsa.p = profundidad;
    return capsa;
}

void volumen::translate(double x, double y, double z){

}

void volumen::initMaterialsVolum(QGLShaderProgram *program){
    materialPrimari = new Material(vec4(0.6,0.6,0.6,1), vec4(0.95,0.6,0.35,1), vec4(0.2,0.2,0.2,1), 50.0f);
    if(materialPrimari != 0){
        materialPrimari->toGPU(program,
                               "matPrimari.comp_ambient",
                               "matPrimari.comp_difusa",
                               "matPrimari.comp_especular",
                               "matPrimari.coef");
    }
}

void volumen::setLoadedLUT(lut *LUT)
{
    colores = LUT;
}
