#ifndef VOLUMEN_H
#define VOLUMEN_H

#include <Common.h>
#include <QObject>
#include <QGLWidget>
#include <objecte.h>
#include <string>
#include "lut.h"
#include "capa.h"
#include "material.h"
#include "raig.h"

using namespace std;

QT_BEGIN_NAMESPACE


QT_END_NAMESPACE

class volumen : public Objecte
{
      // Q_OBJECT

public:

    ~volumen();

    explicit volumen();


    void toGPU(QGLShaderProgram *program);
    // Pintat amb la GPU
    void draw(QGLShaderProgram *program);

    // Calcula la capsa 3D contenidora de l'objecte
    Capsa3D calculCapsa3D();

    // Trasllada un objecte
    void translate(double x, double y, double z);

    void make();
    void draw(GLdouble dx, GLdouble dy, GLdouble dz);

    void addListaVoxels(float x,float y,float z,float v,float i);

    void openVolumen(int a, int al, int p, QString t);

    void setLut(const char *nF);
    void abrirVolumen();
    void setVoxel(int i, int j, int k , float v);


    float getVoxel(int i, int j, int k);

    void raycastingCPU(Camera cam, Capsa3D cub, float opacitat, float saturacio, float sampling, int colorMode, Llum *llum);

    void initMaterialsVolum(QGLShaderProgram *program);

    void setLoadedLUT(lut *LUT);



    lut *colores;

    float planox,planoy,planoz;
    int anchura, altura, profundidad;
    float tnear, tfar;


public slots:

    QList<char *> obtenerEtiqueta();
    char *getImagen();
    const char *getFichero();

    int getAnchura();
    int getAltura();
    int getProfundidad();
    QString getTipoUns();
    void setImagen(char *im);
    void setFichero(char *fi);
    void setAnchura(int an);
    void setAltura(int al);
    void setProfundidad(int pro);
    void setTipoUns(char *unsC);

signals:

protected:

private slots:

private:

    float getVoxelDirecto(int voxel);

    bool intersecta(Raig *raig, Capsa3D cub, float t0, float t1);

    vec4 calculIluminacioFTB(Capsa3D cub, Raig raig, int colorMode, Llum *llum);

    vec4 getColorActual(int mode, float v, int i, int j, int k, Llum *llum, vec4 colorMax);

    GLuint lista;
    int uns;

    FILE *f1;
    char *imagen;
    char *nombreFichero;
    char *unsCS;
    float *voxels;
    unsigned char *capas;

    int NumVoxelsMon;

    vec4  *points;
    vec3  *normals;
    vec4  *colors;

//    static const int NumVoxelsMon =128*128*128;

//    vec4  points[NumVoxelsMon];
//    vec3  normals[NumVoxelsMon];
//    vec4  colors[NumVoxelsMon];

    Raig *raig;

    float UMBRAL_SATURACIO;
    float UMBRAL_OPACITAT;

    int hit;

    Material *materialPrimari;
    Material *materialSecundari;
    Camera camera;

    static const int GS_MODE = 0;
    static const int LUT_MODE = 1;
    static const int PHONG_MODE = 2;
    static const int MIP_MODE = 3;

    QList<char*> etiquetas;
    QList<float> listaVoxels;
};

#endif // VOLUMEN_H
